#include <math.h>

/*  1-dimensional Fourier */
/*  from "Uncorrected tasks of Astrophysics" by Cherepaschuk */
/*  quick Fourier transform,                                 */
/*  if sign > 0 direct transform, if sign < 0 opposit        */

#ifdef   CHR
#undef   CHR
#endif
#ifdef   CHI
#undef   CHI
#endif
#define  CHR(k,l)  r= re_d[k]; re_d[k] = re_d[l]; re_d[l]= r
#define  CHI(k,l)  r= im_d[k]; im_d[k] = im_d[l]; im_d[l]= r

void fft1c(double *re_d, double *im_d, int n, int sign)
{
	register i,ii,j,jj;
	double r,a,b,s,c,t,si,co;
	int m,mm,n1,n2;

	n2 = n1 = n/2;
	mm = n1/2;
	n2++;

	for(jj = 0, j = 1; j < n1; j++) {
		ii = jj + n1;
		CHR(j,ii); 
		CHI(j,ii); 

		j++;
		m = mm;

		while(jj > m-1) {
			jj -= m;
			m /= 2;
		}

		jj += m;
		if( jj <= j)   continue;
		CHR(j, jj);
		CHI(j, jj);

		i = j + n2;
		ii = jj + n2;
		CHR(i, ii);
		CHI(i, ii);
	}

	i = 1;
	t = M_PI;
	if(sign == 0)  return;
	if(sign >  0)  t = -t;

	do {
		si = 0.;
		co = 1.;
		s = sin(t);
		c = cos(t);
		t /= 2.;
		ii = i;
		i += i;
		for(m = 0; m < ii; m++) {
			for(j = m; j < n; j += i) {
				jj = j + ii;
				a = re_d[jj];
				b = im_d[jj];
				r = a * co - b * si;
				re_d[jj] = re_d[j] - r;
				re_d[j]  = re_d[j] + r;
				r = b * co + a * si;
				im_d[jj] = im_d[j] - r;
				im_d[j]  = im_d[j] + r;
			}
			r = c * co - s * si;
			si = c * si + s * co;
			co = r;
		}
	} while (i < n) ;
	return;
}

