/* Don't edit this C-text!
 This is only a C-copy of C++ tv_image_lib.cpp !*/

/*        vs56/vs60/vsbt */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/times.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include "../vs56/vs56_shm.h"
#include "../vs56/vs56_shm_key.h"
#include "../vs60/vs60_shm_key.h"
#include "../vsbt/bttv_shm_key.h"

struct TVmem *tvmem;
struct TVchan *tvch[MaxNumCh], *curch=NULL;
union { char name[5]; int code;} shm_key;
int *shm_pid;
int vs_rep_sig=0;
static void vs_replay(int sig) {
   vs_rep_sig=1;
   signal(sig, vs_replay);
   return;
}

/* Allocate shared memory segment */
void get_vs_sh_mem(char *drv_list[]) {
   int n,i, shmid, shm_size, nch;
   unsigned char *addr;
   char *dname;

   if(curch != NULL) return;

   for(n=0; drv_list[n]!=NULL; n++) {
      dname = drv_list[n];
      if(strcmp(dname,"vs56")==0 || strcmp(dname,"VS56")==0) {
	 shm_size = sizeof(struct TVmem)+sizeof(struct TVchan)*(VSNumCh-1);
	 nch=VSNumCh;
	 strncpy(shm_key.name,vs56_shm_key.name,5);
      }
      if(strcmp(dname,"vs60")==0 || strcmp(dname,"VS60")==0) {
	 shm_size = sizeof(struct TVmem)+sizeof(struct TVchan)*(VSNumCh-1);
	 nch=VSNumCh;
	 strncpy(shm_key.name,vs60_shm_key.name,5);
      }
      if(strcmp(dname,"vsbt")==0 || strcmp(dname,"bttv")==0) {
	 shm_size = sizeof(struct TVmem)+sizeof(struct TVchan)*(BTNumCh-1);
	 nch=BTNumCh;
	 strncpy(shm_key.name,bttv_shm_key.name,5);
      }

      /* try to find existing one */
      shmid = shmget(shm_key.code, shm_size, 0777);
      if (shmid<0) {
	 char msg[80];
	 sprintf(msg,"Can't find shared memory segment '%s' for %s-driver",shm_key.name,dname);
	 perror(msg);
	 if(drv_list[n+1]==NULL) {
	    sleep(1);
	    exit(errno);
	 } else
	    continue;
      }

      /* attach it to our memory space */
      addr = (unsigned char *)shmat ( shmid, NULL, 0 );
      if ((int)(addr) == -1) {
	 char msg[80];
	 sprintf(msg,"Can't attach shared memory segment '%s'",shm_key.name);
	 perror(msg);
	 if(drv_list[n+1]==NULL) {
	    sleep(1);
	    exit(errno);
	 } else
	    continue;
      }
      if((shmctl(shmid, SHM_LOCK, NULL) < 0) < 0) {
	 char msg[80];
	 sprintf(msg,"Can't prevents swapping of shared memory segment '%s'",shm_key.name);
	 perror(msg);
	 if(drv_list[n+1]==NULL) {
	    sleep(1);
	    exit(errno);
	 } else
	    continue;
      }
      tvmem = (struct TVmem *)addr;

      fprintf(stderr,"Find&attach shared memory segment '%s' %dbytes at %x for %s\n",
	   shm_key.name, tvmem->size, (unsigned int)addr,tvmem->grab_name);
      if(tvmem->size != shm_size) {
	 fprintf(stderr,"Wrong TV-memory size:%dbytes needs!\n",shm_size);
	 if(drv_list[n+1]==NULL) {
	    sleep(1);
	    exit(1);
	 } else
	    continue;
      }
      if(tvmem->numch != nch) {
	 fprintf(stderr,"Wrong TV-channels number:%d (%d needs)!\n",tvmem->numch,nch);
	 if(drv_list[n+1]==NULL) {
	    sleep(1);
	    exit(1);
	 } else
	    continue;
      }
      break;
   }
   shm_pid =  &tvmem->drv_pid;

   for(i=0,curch=tvmem->chmem; i<NumCh; i++,curch++) {
      tvch[i] = curch;
   }
   curch = tvmem->chmem;

   signal(SIGUSR1, vs_replay);
}

void get_vs56_sh_mem() {
   static char *dlist[] = {"vs56","vs60","vsbt", NULL};
   get_vs_sh_mem(dlist);
}
void get_vs60_sh_mem() {
   static char *dlist[] = {"vs60","vs56","vsbt", NULL};
   get_vs_sh_mem(dlist);
}
void get_vsbt_sh_mem() {
   static char *dlist[] = {"vsbt","vs60","vs56", NULL};
   get_vs_sh_mem(dlist);
}

void my_sleep(double dt)
{
  int nfd;
  struct timeval tv;
   tv.tv_sec = (int)dt;
   tv.tv_usec = (int)((dt - tv.tv_sec)*1000000.);
   if(tv.tv_sec==0 && tv.tv_usec<10000) tv.tv_usec=10000;
slipping:
   nfd = select(0, (fd_set *)NULL,(fd_set *)NULL,(fd_set *)NULL, &tv);
   if(nfd < 0) {
      if(errno == EINTR) {
	 if(vs_rep_sig) {   /* by USR1 signal?  */
	    vs_rep_sig=0;   /*  ok!              */
	    return;         /*    stop sleeping...*/
	 }
	/*On  Linux,  timeout  is  modified to reflect the amount of
	 time not slept; most other implementations DO NOT do this!*/
	 goto slipping;
      }
      fprintf(stderr,"Error in mydelay(){ select() }. %s\n",strerror(errno));
   }
}

double my_time()
{
  struct timeval tv;
  struct timezone tz;
  int ret;
  double t;
  ret = gettimeofday(&tv, &tz);
  t = (double)tv.tv_sec + (double)tv.tv_usec*0.000001;
  t -= timezone;
  return(t);
}


int vs56_ok() {
   if ( *shm_pid > 0 ) {
      if(kill(*shm_pid, 0) >= 0) return(1);
      else if(errno != ESRCH) return(1);
   }
   return(0);
}

char *vs_name() {
   if(curch == NULL)
       get_vs56_sh_mem();
   return(tvmem->grab_name);
}

int vs_type() {
   if(curch == NULL)
       get_vs56_sh_mem();
   return(curch->vs_type);
}

short *tv_chan_image(int nchan) {
   if(curch == NULL)
       get_vs56_sh_mem();
   if(nchan<0 || nchan>=tvmem->numch) nchan=0;
   curch = tvch[nchan];
   return( curch->image );
}

double tv_chan_exp(double sec) {
   double osec;
   if(curch == NULL)
       get_vs56_sh_mem();
   if(curch->tandem) {
      osec = curch->exposure;
      if(sec>0.)
	 curch->exposure = sec;
      return (osec);
   } else
      return (0.);
}

void tv_chan_go(int clear, int nexp, int nadd,
		int quick_mode, int need_replay, int ccd_mode) {
   if(curch == NULL)
       get_vs56_sh_mem();
   if(nadd < 0)
      quick_mode=0;
   curch->command = IADD | ((clear)? ICLEAR : INULL) | (quick_mode? IQUICK : 0) | (ccd_mode? ICCD : 0);
   curch->nadd = nadd;
   curch->nexp = nexp;
   vs_rep_sig = 0;
   curch->pid = (need_replay)? getpid() : 0;
   vs_rep_sig=0;
   if(quick_mode)
      if(kill(*shm_pid, SIGUSR1)<0)
	 curch->pid = 0;
}

int tv_chan_ccd_mode() {
   return( (curch->command&ICCD)? 1 : 0 );
}

void tv_chan_stop() {
   if(curch == NULL)
       get_vs56_sh_mem();
   curch->command = INULL|(curch->command&ICCD);
   curch->nadd = 0;
   curch->nexp = 0;
}

void tv_chan_init() {
   if(curch == NULL)
       get_vs56_sh_mem();
   curch->command = IINIT|(curch->command&ICCD);
   curch->nadd = 0;
   curch->nexp = 0;
}

void tv_chan_clear() {
   if(curch == NULL)
       get_vs56_sh_mem();
   curch->command = ICLEAR|(curch->command&ICCD);
   curch->nadd = 0;
   curch->nexp = 0;
}

void tv_chan_write() {
   if(curch == NULL)
       get_vs56_sh_mem();
   curch->command = IWRITE|(curch->command&ICCD);
   curch->nadd = 0;
   curch->nexp = 0;
}

int tv_chan_elref(int lev) {
   int oldlev;
   if(curch == NULL)
       get_vs56_sh_mem();
   oldlev = curch->ctrl.ref_lev;
   if (lev>0 && lev<64)
      curch->ctrl.ref_lev = lev;
   return oldlev;
}

void tv_chan_ctrl(int val1, int val2) {
   if(curch == NULL)
       get_vs56_sh_mem();
   if(curch->vs_type <800) {
      if (val1>=0 && val1<256)
	 curch->ctrl.vs60.black_lev = val1;
      if (val2>=0 && val2<256)
	 curch->ctrl.vs60.white_lev = val2;
   } else {
      if (val1>=0 && val1<256)
	 curch->ctrl.bttv.brightness = val1;
      if (val2>=0 && val2<256)
	 curch->ctrl.bttv.contrast = val2;
   }
}
void tv_chan_get_ctrl(int *val1, int *val2) {
   if(curch == NULL)
       get_vs56_sh_mem();
   if(curch->vs_type <800) {
      *val1 = curch->ctrl.vs60.black_lev;
      *val2 = curch->ctrl.vs60.white_lev;
   } else {
      *val1 = curch->ctrl.bttv.brightness;
      *val2 = curch->ctrl.bttv.contrast;
   }
}

int tv_chan_form(int form) {
   if(curch == NULL)
       get_vs56_sh_mem();
   if ( form > 0 )
      curch->next_form = form;
   return curch->form;
}

void tv_chan_frame(int col0, int lin0, int width, int height) {
   if(curch == NULL)
       get_vs56_sh_mem();

   if(width < MinFrame) width=MinFrame;
   if(width > curch->img_width) width=curch->img_width;
   if(height<MinFrame) height=MinFrame;
   if(height > curch->img_height) height=curch->img_height;
   if(col0 < 0) col0=0;
   if(col0 > curch->img_width-width) col0=curch->img_width-width;
   if(lin0 < 0) lin0=0;
   if(lin0 > curch->img_height-height) lin0=curch->img_height-height;

   curch->frm_col0 = col0;
   curch->frm_lin0 = lin0;
   if(width < curch->frm_width) {
      if(curch->subfrm_width > width) {
	 curch->subfrm_col0 = 0;
	 curch->subfrm_width = width;
      } else if(curch->subfrm_col0 + curch->subfrm_width > width)
	 curch->subfrm_col0 = width - curch->subfrm_width;
      if(curch->subfrm2_width > width) {
	 curch->subfrm2_col0 = 0;
	 curch->subfrm2_width = width;
      } else if(curch->subfrm2_col0 + curch->subfrm2_width > width)
	 curch->subfrm2_col0 = width - curch->subfrm2_width;
   }
   curch->frm_width = width;
   if(height < curch->frm_height) {
      if(curch->subfrm_height > height) {
	 curch->subfrm_lin0 = 0;
	 curch->subfrm_height = height;
      } else if(curch->subfrm_lin0 + curch->subfrm_height > height)
	 curch->subfrm_lin0 = height - curch->subfrm_height;
      if(curch->subfrm2_height > height) {
	 curch->subfrm2_lin0 = 0;
	 curch->subfrm2_height = height;
      } else if(curch->subfrm2_lin0 + curch->subfrm2_height > height)
	 curch->subfrm2_lin0 = height - curch->subfrm2_height;
   }
   curch->frm_height = height;
}

void tv_chan_get_frame(int *col0, int *lin0, int *width, int *height) {
   if(curch == NULL)
       get_vs56_sh_mem();
   *col0   = curch->frm_col0;
   *lin0   = curch->frm_lin0;
   *width  = curch->frm_width;
   *height = curch->frm_height;
}

void tv_chan_subframe(int col0, int lin0, int width, int height) {
   if(curch == NULL)
       get_vs56_sh_mem();

   if(width < 3) width=3;
   if(width > curch->frm_width) width=curch->frm_width;
   if(height < 3) height=3;
   if(height > curch->frm_height) height=curch->frm_height;
   if(col0 < 0) col0=0;
   if(col0 > curch->frm_width-width) col0=curch->frm_width-width;
   if(lin0 < 0) lin0=0;
   if(lin0 > curch->frm_height-height) lin0=curch->frm_height-height;

   curch->subfrm_col0 = col0;
   curch->subfrm_lin0 = lin0;
   curch->subfrm_width = width;
   curch->subfrm_height = height;
}

void tv_chan_get_subframe(int *col0, int *lin0, int *width, int *height) {
   if(curch == NULL)
       get_vs56_sh_mem();
   *col0   = curch->subfrm_col0;
   *lin0   = curch->subfrm_lin0;
   *width  = curch->subfrm_width;
   *height = curch->subfrm_height;
}

void tv_chan_subframe2(int col0, int lin0, int width, int height) {
   if(curch == NULL)
       get_vs56_sh_mem();

   if(width < 3) width=3;
   if(width > curch->frm_width) width=curch->frm_width;
   if(height < 3) height=3;
   if(height > curch->frm_height) height=curch->frm_height;
   if(col0 < 0) col0=0;
   if(col0 > curch->frm_width-width) col0=curch->frm_width-width;
   if(lin0 < 0) lin0=0;
   if(lin0 > curch->frm_height-height) lin0=curch->frm_height-height;

   curch->subfrm2_col0 = col0;
   curch->subfrm2_lin0 = lin0;
   curch->subfrm2_width = width;
   curch->subfrm2_height = height;
}

void tv_chan_get_subframe2(int *col0, int *lin0, int *width, int *height) {
   if(curch == NULL)
       get_vs56_sh_mem();
   *col0   = curch->subfrm2_col0;
   *lin0   = curch->subfrm2_lin0;
   *width  = curch->subfrm2_width;
   *height = curch->subfrm2_height;
}

void tv_chan_point(int col, int lin) {
   if(curch == NULL)
       get_vs56_sh_mem();
   curch->pnt_col = col;
   curch->pnt_lin = lin;
}

void tv_chan_get_point(int *col, int *lin) {
   if(curch == NULL)
       get_vs56_sh_mem();
   *col = curch->pnt_col;
   *lin = curch->pnt_lin;
}

void  tv_chan_center(double x, double y) {
   if(curch == NULL)
       get_vs56_sh_mem();
   curch->center_x = x;
   curch->center_y = y;
}

void  tv_chan_get_center(double *x, double *y) {
   if(curch == NULL)
       get_vs56_sh_mem();
   *x = curch->center_x;
   *y = curch->center_y;
}

int tv_chan_img_width() {
   if(curch == NULL)
       get_vs56_sh_mem();
   return(curch->img_width);
}

int tv_chan_img_height() {
   if(curch == NULL)
       get_vs56_sh_mem();
   return(curch->img_height);
}

int tv_chan_seq_num() {
   if(curch == NULL) get_vs56_sh_mem();
   return(curch->seqn);
}

int tv_chan_set_seq_num(int new_num) {
   int old_num;
   if(curch == NULL) get_vs56_sh_mem();
   old_num = curch->seqn;
   curch->seqn = new_num;
   return(old_num);
}

char *tv_chan_msg() {
   if(curch == NULL) get_vs56_sh_mem();
   return(curch->msg);
}

int tv_chan_seq_msg() {
   if(curch == NULL) get_vs56_sh_mem();
   return(curch->seqmsg);
}

int tv_chan_tandem() {
   if(curch == NULL) get_vs56_sh_mem();
   return(curch->tandem);
}

int tv_chan_activ() {
   if(curch == NULL) get_vs56_sh_mem();
   return(curch->activ);
}

double tv_chan_tstart() {
   if(curch == NULL) get_vs56_sh_mem();
   return(curch->tstart);
}

double tv_chan_tlast() {
   if(curch == NULL) get_vs56_sh_mem();
   return(curch->tcurr);
}

int tv_chan_added() {
   if(curch == NULL) get_vs56_sh_mem();
   return(curch->nadded);
}

int tv_chan_addlev() {
   if(curch == NULL) get_vs56_sh_mem();
   return(curch->addlev);
}

void tv_chan_set_added(int nadd) {
   if(curch == NULL) get_vs56_sh_mem();
   curch->nadded = nadd;
}

void tv_chan_set_addlev(int tv_lev) {
   if(curch == NULL) get_vs56_sh_mem();
   curch->addlev = tv_lev;
}

int tv_chan_ccd_bias(int new_bias_lev) {
   int old_one;
   if(curch == NULL)
       get_vs56_sh_mem();
   old_one = curch->bias;
   curch->bias = new_bias_lev;
   return old_one;
}

int *tv_chan_ccd_flat(int *flats, int first, int last) {
   int i;
   if(curch == NULL)
       get_vs56_sh_mem();
   if(last>MaxWidth) last=MaxWidth;
   if(first>last) first=last;
   if(flats!=NULL && last>=0) {
      for(i=first; i<last; i++)  curch->flat[i] = flats[i];
   }
   return(curch->flat);
}

char *tv_chan_fits_header() {
   if(curch == NULL)
       get_vs56_sh_mem();
   return(curch->fits_header);
}

char *tv_chan_fits_line(char *fname) {
   int i,nfl;
   char fln[10];
   char *flp = tv_chan_fits_header();
   for(i=0;i<8;i++) {
      if(*fname != '\0') fln[i] = *fname++;
      else fln[i] = ' ';
   }
   fln[8] = '=';
   fln[9] = '\0';
   for(nfl=0; nfl<36; nfl++, flp+=80) {
      if(*flp == '\0')  return(NULL);
      if(strncmp(fln,flp,9) == 0) return(flp);
   }
   return(NULL);
}

char  *tv_chan_set_fits_line(char *fline) {
   int i,nfl,space;
   char *flp = tv_chan_fits_header();
   if(fline[8] != '=') return(NULL);
   for(space=i=0;i<8;i++) {
      if(space && fline[i]!=' ') return(NULL);
      if(isupper(fline[i])) continue;
      if(isdigit(fline[i])) continue;
      if(fline[i]=='-') continue;
      if(fline[i]=='_') continue;
      if(fline[i]==' ') {space=1;continue;}
      return(NULL);
   }
   for(nfl=0; nfl<36; nfl++, flp+=80) {
      if(*flp == '\0' || strncmp(fline,flp,9) == 0) {
	 for(i=0;i<80;i++) {
	    if(*fline != '\0') flp[i] = *fline++;
	    else flp[i] = ' ';
	 }
	 return(flp);
      }
   }
   return(NULL);
}
