/* VS56/VS60 TV-channel autorefresh */
/* Usage:                           */
/*     tvauto [ vsdrv:Nchan [ Tstep ] ]   */
/* Defaults:     vs56:3        10.0      */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/times.h>

#include "tv_image_lib.h"

void main(int argc, char *argv[]) {
   short *img;                     /* image memory */
   int imgw, imgh, imgw_o, imgh_o; /* image size   */
   int nchan = 3;                  /* TV-chan. number */
   int col0, lin0, frmw, frmh;     /* frame1: area of interest */
   int col0_o, lin0_o, frmw_o, frmh_o;
   double timestep=10.0;
   int nseq, nseq_o, mseq, mseq_o;
   int myact=0;
   char tv_driver[20] = "";

   if(argc>1) {
      char *p = strchr(argv[1],':');
      if(p!=NULL || argv[1][0] == 'v' || argv[1][0] == 'V' || argv[1][0] == 'b') {
	 strncpy(tv_driver,argv[1],19);
	 if(p!=NULL) nchan = atoi(p+1);
      } else
	 nchan = atoi(argv[1]);
   }
   if(strncmp(tv_driver,"vs56",4)==0 || strncmp(tv_driver,"VS56",4)==0) get_vs56_sh_mem();
   if(strncmp(tv_driver,"vs60",4)==0 || strncmp(tv_driver,"VS60",4)==0) get_vs60_sh_mem();
   if(strncmp(tv_driver,"vsbt",4)==0 || strncmp(tv_driver,"bttv",4)==0) get_vsbt_sh_mem();

   if (argc>2) timestep = atof(argv[2]);
   if (timestep<5.0) timestep=5.0;

   get_vs56_sh_mem();
   img = tv_chan_image (nchan);

   imgw_o = imgw = tv_chan_img_width();
   imgh_o = imgh = tv_chan_img_height();
   nseq_o = nseq = tv_chan_seq_num();
   mseq_o = mseq = tv_chan_seq_msg();
   tv_chan_get_frame(&col0, &lin0, &frmw, &frmh);
   tv_chan_get_frame(&col0_o, &lin0_o, &frmw_o, &frmh_o);

   while (1) {
      my_sleep(timestep-2.0);
      if(vs56_ok()) {
	 imgw = tv_chan_img_width();
	 imgh = tv_chan_img_height();
	 nseq = tv_chan_seq_num();
	 mseq = tv_chan_seq_msg();
	 tv_chan_get_frame(&col0, &lin0, &frmw, &frmh);
	 if(imgw_o==imgw && imgh_o==imgh &&
	    col0_o==col0 && lin0_o==lin0 &&
	    frmw_o==frmw && frmh_o==frmh &&
	    nseq_o==nseq && mseq_o==mseq) {
	    tv_chan_go(1, 1, 1, 0, 0, tv_chan_ccd_mode());
	    my_sleep(2.0);
	    nseq = tv_chan_seq_num();
	    mseq = tv_chan_seq_msg();
	    myact = 1;
	 } else {
	    my_sleep(180.0);
	    myact = 0;
	 }
	 imgw_o=imgw; imgh_o=imgh;
	 col0_o=col0; lin0_o=lin0;
	 frmw_o=frmw; frmh_o=frmh;
	 nseq_o=nseq; mseq_o=mseq;
      }
   }
}
