/*                                     */
/*   AMCC Operation Register Offsets   */
/*                                     */

#define AMCC_OP_REG_OMB1         0x00
#define AMCC_OP_REG_OMB2         0x04
#define AMCC_OP_REG_OMB3         0x08
#define AMCC_OP_REG_OMB4         0x0c
#define AMCC_OP_REG_IMB1         0x11
#define AMCC_OP_REG_IMB2         0x14
#define AMCC_OP_REG_IMB3         0x18
#define AMCC_OP_REG_IMB4         0x1c
#define AMCC_OP_REG_FIFO         0x20
#define AMCC_OP_REG_MWAR         0x24
#define AMCC_OP_REG_MWTC         0x28
#define AMCC_OP_REG_MRAR         0x2c
#define AMCC_OP_REG_MRTC         0x30
#define AMCC_OP_REG_MBEF         0x34
#define AMCC_OP_REG_INTCSR       0x38
#define AMCC_OP_REG_MCSR         0x3c
#define AMCC_OP_REG_MCSR_NVDATA  (AMCC_OP_REG_MCSR + 2) // Data in byte 2
#define AMCC_OP_REG_MCSR_NVCMD   (AMCC_OP_REG_MCSR + 3) // Command in byte 3

/* tag Bus_Master_Cntr_Statatus_Register */
struct BMCSR{
  unsigned pci_add_fifo_full:1;          //0
  unsigned pci_add_fifo_4s:1;            //1
  unsigned pci_add_fifo_Empty:1;         //2
  unsigned add_pci_fifo_full:1;          //3
  unsigned add_pci_fifo_4s:1;            //4
  unsigned add_pci_fifo_empty:1;         //5
  unsigned pci_add_tras_cont:1;          //6
  unsigned add_pci_tras_cont:1;          //7
  unsigned wtc_wr_vs_rd_prior:1;         //8
  unsigned wtc_fifo_manegment_scheme:1;  //9
  unsigned wtc_wr_trasfer_enable:1;      //10
  unsigned reserved11:1;                 //11
  unsigned rtc_rd_vs_wr_prior:1;         //12
  unsigned rtc_fifo_manegment_scheme:1;  //13
  unsigned rtc_rd_trasfer_enable:1;      //14
  unsigned reserved15:1;                 //15
  unsigned nv_operation_ad:8;            //16..23
  unsigned add_reset:1;                  //24
  unsigned pci_add_fifo_reset:1;         //25
  unsigned add_pci_fifo_reset:1;         //26
  unsigned mb_reset:1;                   //27
  unsigned nv_access_ctrl:3;             //29..31
};

