/* x86 I/O functions for VS60 control programs under Linux  */
/*   "Byte" I/O        -  outb(), inb()                     */
/*   "Word" I/O        -  outw(), inw()                     */
/*   "Long" I/O        -  outl(), inl()                     */
/*   "string versions" - insb_rep(),  outsb_rep()           */
/*                       insw_rep(),  outsw_rep()           */
/*                       insl_rep(),  outsl_rep()           */


static inline void outb (unsigned short port, unsigned char val)
  {
   __asm__ volatile ("out%B0 %0,%1" : :"a" (val), "d" (port));
  }

static inline unsigned char inb (unsigned short port)
 {
   unsigned char ret;
   __asm__ volatile ("in%B0 %1,%0" : "=a" (ret) : "d" (port));
   return ret;
 }
static inline void insb_rep(unsigned short port, void * addr, unsigned long count)
{
__asm__ volatile ("cld ; rep ; insb"
	      :"=D" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count));
}

static inline void outsb_rep(unsigned short port, void * addr, unsigned long count)
{
__asm__ volatile ("cld ; rep ; outsb"
	      :"=S" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count));
}

static inline void outw(unsigned short port, unsigned short value)
{
__asm__ volatile ("outw %0,%1"
		::"a" ((unsigned short) value),"d" ((unsigned short) port));
}

static inline unsigned short inw(unsigned short port)
{
	unsigned short _v;
__asm__ volatile ("inw %1,%0"
		:"=a" (_v):"d" ((unsigned short) port));
	return _v;
}
static inline void insw_rep(unsigned short port, void * addr, unsigned long count)
{
__asm__ volatile ("cld ; rep ; insw"
	      :"=D" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count));
}

static inline void outsw_rep(unsigned short port, void * addr, unsigned long count)
{
__asm__ volatile ("cld ; rep ; outsw"
	      :"=S" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count));
}

static inline void outl(unsigned short port, unsigned long value)
{
__asm__ volatile ("outl %0,%1"
		::"a" ((unsigned long) value),"d" ((unsigned short) port));
}

static inline unsigned long inl(unsigned short port)
{
	unsigned long _v;
__asm__ volatile ("inl %1,%0"
		:"=a" (_v):"d" ((unsigned short) port));
	return _v;
}
static inline void insl_rep(unsigned short port, void * addr, unsigned long count)
{
__asm__ volatile ("cld ; rep ; insl"
	      :"=D" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count));
}

static inline void outsl_rep(unsigned short port, void * addr, unsigned long count)
{
__asm__ volatile ("cld ; rep ; outsl"
	      :"=S" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count));
}
